unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KozyTetris, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    KozyTetris1: TKozyTetris;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    NextWin: TPaintBox;
    Label6: TLabel;
    Label7: TLabel;
    CurrWin: TPaintBox;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure KozyTetris1LineFull(Sender: TObject; Lines: Integer);
    procedure KozyTetris1GameEnd(Sender: TObject);
    procedure KozyTetris1NewPiece(Sender: TObject; Piece: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Points, FullLines: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  FullLines := 0;
  Label2.Caption := '0';
  Label4.Caption := '0';

  with KozyTetris1 do
    begin
      StartNewGame;
    end;

  timer1.enabled := TRUE;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  with KozyTetris1 do
    begin
      MoveDown;
    end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    '7' : KozyTetris1.MoveLeft;
    '8' : KozyTetris1.RotatePiece(FALSE);
    '9' : KozyTetris1.MoveRight;
    '4' : KozyTetris1.MoveDown;
    '0' : KozyTetris1.DropDown;
  end;
end;

procedure TForm1.KozyTetris1LineFull(Sender: TObject; Lines: Integer);
begin
  Inc(FullLines, Lines);
  Inc(Points, KozyTetris1.EmptyLines + 5*Lines - 1);

  Label2.Caption := IntToStr(FullLines);
  Label4.Caption := IntToStr(Points);

  with KozyTetris1 do
    label5.caption := format(
      'TKozyTetris component:'#13+
      'EmptyLines = %d'#13'TotalLines = %d',
      [EmptyLines, Rows]);
end;

procedure TForm1.KozyTetris1GameEnd(Sender: TObject);
begin
  Timer1.Enabled := FALSE;
  ShowMessage('Game ended.');
end;

procedure TForm1.KozyTetris1NewPiece(Sender: TObject; Piece: Integer);
var R: TRect;
begin
  with NextWin do
    R := Rect(0, 0, Width, Height);

  with NextWin.Canvas do
    begin
      Brush.Color := KozyTetris1.Color;
      FillRect(R);
    end;

  KozyTetris1.DrawPieceOnCanvas(NextWin.Canvas, 1, 1, KozyTetris1.NextPieceIndex);

  with CurrWin.Canvas do
    begin
      Brush.Color := KozyTetris1.Color;
      FillRect(R);
    end;

  KozyTetris1.DrawPieceOnCanvas(CurrWin.Canvas, 1, 1, KozyTetris1.CurrentPiece);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with NextWin do
    begin
      Width := 5 * KozyTetris1.BlockSize;
      Height := Width;
    end;

  with CurrWin do
    begin
      Width := 5 * KozyTetris1.BlockSize;
      Height := Width;
    end;
end;

end.
